# coding: utf-8

"""
    ibl-data-manager

    API for iblai

    The version of the OpenAPI document: 3.66.0-ai-plus
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CourseLicenseAssignmentCreate(BaseModel):
    """
    Request serializer for CourseLicenseAssignmentView POST endpoint
    """ # noqa: E501
    license_id: StrictInt = Field(description="The ID of the course license")
    user_id: Optional[StrictInt] = Field(default=None, description="The user ID to assign the license to")
    email: Optional[StrictStr] = Field(default=None, description="The email to assign the license to")
    platform_key: Optional[StrictStr] = Field(default=None, description="The unique identifier for the platform")
    platform_org: Optional[StrictStr] = Field(default=None, description="The organization identifier for the platform")
    active: Optional[StrictBool] = Field(default=True, description="Whether the assignment is active")
    fulfilled: Optional[StrictBool] = Field(default=False, description="Whether the assignment has been fulfilled")
    metadata: Optional[Dict[str, Any]] = Field(default=None, description="Additional metadata for the assignment")
    __properties: ClassVar[List[str]] = ["license_id", "user_id", "email", "platform_key", "platform_org", "active", "fulfilled", "metadata"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CourseLicenseAssignmentCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CourseLicenseAssignmentCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "license_id": obj.get("license_id"),
            "user_id": obj.get("user_id"),
            "email": obj.get("email"),
            "platform_key": obj.get("platform_key"),
            "platform_org": obj.get("platform_org"),
            "active": obj.get("active") if obj.get("active") is not None else True,
            "fulfilled": obj.get("fulfilled") if obj.get("fulfilled") is not None else False,
            "metadata": obj.get("metadata")
        })
        return _obj


