# coding: utf-8

"""
    ibl-data-manager

    API for iblai

    The version of the OpenAPI document: 3.66.0-ai-plus
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from iblai.models.mentor_eval_question import MentorEvalQuestion
from typing import Optional, Set
from typing_extensions import Self

class MentorEval(BaseModel):
    """
    MentorEval
    """ # noqa: E501
    id: StrictInt
    mentor: StrictStr
    questions: List[MentorEvalQuestion]
    eval_id: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    passing_score: Optional[StrictInt] = None
    evaluation_prompt: Optional[StrictStr] = None
    question_set: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["id", "mentor", "questions", "eval_id", "name", "passing_score", "evaluation_prompt", "question_set"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MentorEval from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
            "mentor",
            "questions",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in questions (list)
        _items = []
        if self.questions:
            for _item in self.questions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['questions'] = _items
        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if question_set (nullable) is None
        # and model_fields_set contains the field
        if self.question_set is None and "question_set" in self.model_fields_set:
            _dict['question_set'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MentorEval from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "mentor": obj.get("mentor"),
            "questions": [MentorEvalQuestion.from_dict(_item) for _item in obj["questions"]] if obj.get("questions") is not None else None,
            "eval_id": obj.get("eval_id"),
            "name": obj.get("name"),
            "passing_score": obj.get("passing_score"),
            "evaluation_prompt": obj.get("evaluation_prompt"),
            "question_set": obj.get("question_set")
        })
        return _obj


