# coding: utf-8

"""
    ibl-data-manager

    API for iblai

    The version of the OpenAPI document: 3.66.0-ai-plus
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from typing import Optional, Set
from typing_extensions import Self

class PerlearnerEngagementVideosData(BaseModel):
    """
    PerlearnerEngagementVideosData
    """ # noqa: E501
    course_id: StrictStr = Field(description="Edx Course ID")
    name: StrictStr = Field(description="Course Name")
    total_videos: StrictInt = Field(description="Total course videos")
    watched: StrictInt = Field(description="Total videos watched by student")
    total_time_watch: StrictInt = Field(description="Total time user watched video")
    average_class_watch: Union[StrictFloat, StrictInt] = Field(description="Average videos watched by students in course")
    class_time_average: Union[StrictFloat, StrictInt] = Field(description="Average time spent by students on this course")
    __properties: ClassVar[List[str]] = ["course_id", "name", "total_videos", "watched", "total_time_watch", "average_class_watch", "class_time_average"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PerlearnerEngagementVideosData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PerlearnerEngagementVideosData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "course_id": obj.get("course_id"),
            "name": obj.get("name"),
            "total_videos": obj.get("total_videos"),
            "watched": obj.get("watched"),
            "total_time_watch": obj.get("total_time_watch"),
            "average_class_watch": obj.get("average_class_watch"),
            "class_time_average": obj.get("class_time_average")
        })
        return _obj


