# coding: utf-8

"""
    ibl-data-manager

    API for iblai

    The version of the OpenAPI document: 3.66.0-ai-plus
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RecommendedCoursesResponse(BaseModel):
    """
    Response serializer for RecommendedCoursesView
    """ # noqa: E501
    results: List[Dict[str, Any]] = Field(description="List of content items matching the search criteria")
    count: StrictInt = Field(description="Total number of items matching the search criteria")
    next: Optional[StrictStr] = Field(description="URL for the next page of results")
    previous: Optional[StrictStr] = Field(description="URL for the previous page of results")
    current_page: StrictInt = Field(description="Current page number")
    total_pages: StrictInt = Field(description="Total number of pages")
    facets: Optional[Dict[str, Any]] = Field(default=None, description="Facet information for filtering")
    __properties: ClassVar[List[str]] = ["results", "count", "next", "previous", "current_page", "total_pages", "facets"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RecommendedCoursesResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if next (nullable) is None
        # and model_fields_set contains the field
        if self.next is None and "next" in self.model_fields_set:
            _dict['next'] = None

        # set to None if previous (nullable) is None
        # and model_fields_set contains the field
        if self.previous is None and "previous" in self.model_fields_set:
            _dict['previous'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RecommendedCoursesResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "results": obj.get("results"),
            "count": obj.get("count"),
            "next": obj.get("next"),
            "previous": obj.get("previous"),
            "current_page": obj.get("current_page"),
            "total_pages": obj.get("total_pages"),
            "facets": obj.get("facets")
        })
        return _obj


